import { Patch, PatchListener } from "immer";
/**
 * Select function.
 */
export declare type Select<State, T = any> = (state: State) => T;
/**
 * select's state.
 */
export declare type SelectState = {
    state: any;
    version: number;
};
/**
 * Changed listener.
 */
export declare type ChangedListener<State> = (state: State) => void;
/**
 * Context.
 */
export declare class Context<State> {
    /**
     * patche listener.
     */
    patchListener?: PatchListener;
    /**
     * current state.
     */
    private state?;
    /**
     * current draft state.
     */
    private draft?;
    /**
     * listeners.
     */
    private changed;
    /**
     * Consumer's select props.
     */
    private selects;
    /**
     * set state.
     */
    setState: (state: State) => void;
    /**
     * get state.
     */
    getState: () => State | undefined;
    /**
     * update state.
     */
    updateState: (update: (state: State) => void) => void;
    /**
     * apply patches.
     */
    applyPatches: (patches: Patch[]) => void;
    /**
     * subscribe state change.
     */
    subscribe(changed: ChangedListener<State>): void;
    /**
     * unsubscribe state change.
     */
    unsubscribe(changed: ChangedListener<State>): void;
    /**
     * register select function.
     */
    register(select: Select<State>): void;
    /**
     * getSelectState.
     */
    getSelectState(select: Select<State>): SelectState;
}
