"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
function createProvider(Provider, context) {
    /**
     * SrimmerProvider.
     */
    return /** @class */ (function (_super) {
        tslib_1.__extends(SrimmerProvider, _super);
        /**
         * props to state.
         */
        function SrimmerProvider(props) {
            var _this = _super.call(this, props) || this;
            _this.state = { state: props.state };
            context.setState(props.state);
            context.subscribe(function (state) { return _this.setState({ state: state }); });
            return _this;
        }
        /**
         * render.
         */
        SrimmerProvider.prototype.render = function () {
            return (react_1.default.createElement(Provider, { value: this.state.state }, this.props.children));
        };
        return SrimmerProvider;
    }(react_1.default.Component));
}
exports.createProvider = createProvider;
//# sourceMappingURL=Provider.js.map