import React from "react";
import { Patch, PatchListener } from "immer";
import { Select } from "./Context";
export { Patch };
export declare type Select<T extends React.ComponentType<{
    children: any;
}>> = T extends React.ComponentType<{
    children: (selected: infer R) => React.ReactNode;
}> ? R : never;
export declare function define<State extends object>(): {
    Provider: {
        new (props: import("./Provider").ProviderProps<State>): {
            render(): JSX.Element;
            setState<K extends "state">(state: import("./Provider").ProviderState<State> | ((prevState: Readonly<import("./Provider").ProviderState<State>>, props: Readonly<import("./Provider").ProviderProps<State>>) => import("./Provider").ProviderState<State> | Pick<import("./Provider").ProviderState<State>, K> | null) | Pick<import("./Provider").ProviderState<State>, K> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callBack?: (() => void) | undefined): void;
            readonly props: Readonly<{
                children?: React.ReactNode;
            }> & Readonly<import("./Provider").ProviderProps<State>>;
            state: Readonly<import("./Provider").ProviderState<State>>;
            context: any;
            refs: {
                [key: string]: React.ReactInstance;
            };
        };
    };
    Consumer: {
        new <T>(props: import("./Consumer").ConsumerProps<State, any>): {
            shouldComponentUpdate(): boolean;
            render(): JSX.Element;
            setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("./Consumer").ConsumerProps<State, T>>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callBack?: (() => void) | undefined): void;
            readonly props: Readonly<{
                children?: React.ReactNode;
            }> & Readonly<import("./Consumer").ConsumerProps<State, T>>;
            state: Readonly<{}>;
            context: any;
            refs: {
                [key: string]: React.ReactInstance;
            };
        };
    };
    get: () => State | undefined;
    set: (state: State) => void;
    update: (update: (state: State) => void) => void;
    applyPatches: (patches: Patch[]) => void;
    onPatches: (patchListener: PatchListener) => void;
    select: <T>(select: Select<State, T>) => (props: {
        children: (s: T) => React.ReactNode;
    }) => JSX.Element;
};
