import React from "react";
import { Context } from "./Context";
import { createConsumer } from "./Consumer";
import { createProvider } from "./Provider";
export function define() {
    const context = new Context();
    const { Provider, Consumer } = React.createContext({});
    const SrimmerProvider = createProvider(Provider, context);
    const SrimmerConsumer = createConsumer(Consumer, context);
    return {
        Provider: SrimmerProvider,
        Consumer: SrimmerConsumer,
        get: context.getState,
        set: context.setState,
        update: context.updateState,
        applyPatches: context.applyPatches,
        onPatches: (patchListener) => {
            context.patchListener = patchListener;
        },
        select: function select(select) {
            return (props) => (React.createElement(SrimmerConsumer, { select: select }, props.children));
        }
    };
}
//# sourceMappingURL=index.js.map